Public Class FrmPuerto
    Sub GetSerialPortNames()
        'Limpiamos el combo
        ComboBox1.Items.Clear()

        ' Show all available COM ports.
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBox1.Items.Add(sp)
        Next

        'Rutina para la seleccion del puerto
        Dim TextPort As String

        TextPort = frmMain.SerialPort1.PortName     'Capturamos el numero de puerto

        If ComboBox1.Items.Count > 0 Then
            Dim Index As Integer

            Index = ComboBox1.FindString(TextPort)
            If Index <> -1 Then
                ComboBox1.SelectedIndex = Index
            Else
                MsgBox("El puerto serie no esta disponible en este PC...", MsgBoxStyle.Exclamation, "Comunicaciones")
                ComboBox1.SelectedIndex = 0
            End If

        Else
            'No hay puertos disponibes
            MsgBox("No hay puertos serie disponibles...", MsgBoxStyle.Exclamation, "Comunicaciones")
            Exit Sub
        End If
    End Sub
    Private Sub GetBaudRate()
        'llenamos el combo de velocidad
        ComboBox2.Items.Clear()
        ComboBox2.Items.AddRange(New Object() {"9600", "19200", "38400", "57600", "115200"})
        Dim VelPort As String
        Dim Index As Integer
        VelPort = frmMain.SerialPort1.BaudRate  'Capturamos el numero de puerto
        Index = ComboBox2.FindString(VelPort)
        If Index <> -1 Then
            ComboBox2.SelectedIndex = Index
        Else
            ComboBox2.SelectedIndex = 0
        End If
    End Sub


   

    Private Sub FrmPuerto_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Capturamos el valor de la velocidad anterior del puerto
        VelocidadPuertoAnt = Val(mINI.IniGet(ArchivoIni, "Settings", "Baudios", "9600"))

        'Capturamos los puertos disponibles y seleccionamos el que hay
        Call GetSerialPortNames()
        'Capturamos la velocidad del puerto
        Call GetBaudRate()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        mINI.IniWrite(ArchivoIni, "Settings", "Puerto", ComboBox1.Text)
        mINI.IniWrite(ArchivoIni, "Settings", "Baudios", ComboBox2.Text)

        ' Enviamos el valor de velocidad del puerto serie
        If ModoRS232 = True Then Call ModuloRs232.Velocidad_Port(ComboBox2.SelectedIndex)
        ' Enviamos tambien el cambio de la velocidad por el USB
        If ModoRS232 = False Then Call ModuloUSB.Velocidad_Port(ComboBox2.SelectedIndex)

        ' Miramos si se ha cambiado la velocidad del puerto
        If VelocidadPuertoAnt <> Val(ComboBox2.Text) Then
            ' Actualizamos el valor de la velocidad
            VelocidadPuertoAnt = Val(ComboBox2.Text)

            MsgBox("Inicialice su controladora y pulse aceptar...", MsgBoxStyle.Information, "Inicializacin...")
        End If

        'Si el puerto esta abierto lo cerramos
        If frmMain.SerialPort1.IsOpen Then frmMain.SerialPort1.Close()

        If ModoRS232 = True Then
            'Volvemos a abrir el puerto con los nuevos parametros
            Call ModuloRs232.AbrirPuerto()
        Else
            'Cerramos el USB
            Call ModuloUSB.Close_USB()
            Call ModuloUSB.AbrirUSB(True)
        End If
        ' Leemos las posiciones
        Call frmMain.LeerPosiciones()

        Me.Close()
    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub
End Class